"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Return a test default object
 * @param  {string}  options.name      The name of the test
 * @param  {function}  options.func    The function to call
 * @param  {object}  options.args      The arguments to pass to the function
 * @return {object}                    The final test object
 */
function createTest({ type, func = () => false, args = {}, }) {
    return {
        type,
        func,
        args,
    };
}
exports.createTest = createTest;
function createTestResult(test, valid, result) {
    return Object.assign(Object.assign({}, test), { valid,
        result });
}
exports.createTestResult = createTestResult;
